Bug 465995 - NetworkManager writes useless resolv.conf
NetworkManager writes useless resolv.conf
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: NetworkManager (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Dan Williams
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-10-07 13:15 EDT by Tom Tromey
Modified: 2014-08-11 01:46 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-04-24 13:02:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Tom Tromey 2008-10-07 13:15:10 EDT
I set up a Manual IPv4 connection in NetworkManager.
In the DNS Servers field I put the servers from my ISP:
"207.189.200.5, 207.189.215.4"
In the Search field I put "redhat.com".

However, when I choose this connection, I get a resolv.conf
that does not reflect this information:

# generated by NetworkManager, do not edit!



# No nameservers found; try putting DNS servers into your
# ifcfg files in /etc/sysconfig/network-scripts like so:
#
# DNS1=xxx.xxx.xxx.xxx
# DNS2=xxx.xxx.xxx.xxx
# DOMAIN=lab.foo.com bar.foo.com
Comment 1 Dan Williams 2008-10-07 16:41:54 EDT
Again, which RPM version of NetworkManager?
Comment 2 Tom Tromey 2008-10-08 09:25:24 EDT
opsy. rpm -q NetworkManager
NetworkManager-0.7.0-0.11.svn4022.4.fc8
Comment 3 Matt Castelein 2008-10-08 16:46:28 EDT
I have this same issue in F9.  All my interfaces are set NOT to be controlled by NetworkManager, and the NetworkManager service itself is disabled.  I also have PEERDNS=no in each of my ifcfg-eth(n) files..  Yet somehow when I reboot, I get this empty resolv.conf created by NetworkManager in place of my useful entries.

NetworkManager-0.7.0-0.11.svn4022.4.fc9.x86_64
Comment 4 Matt Castelein 2008-10-08 17:09:07 EDT
Incidentally, I actually already have DNS1=127.0.0.1 in my ifcfg-xxx files, but it seems to be ignoring that as well since it suggests I add it.
Comment 5 Dan Williams 2008-10-08 17:19:44 EDT
(In reply to comment #3)
> I have this same issue in F9.  All my interfaces are set NOT to be controlled
> by NetworkManager, and the NetworkManager service itself is disabled.  I also
> have PEERDNS=no in each of my ifcfg-eth(n) files..  Yet somehow when I reboot,
> I get this empty resolv.conf created by NetworkManager in place of my useful
> entries.

If you've 'chkconfig NetworkManager off' then NM won't have anything to do with writing out your resolv.conf.  After turning NM off, you'll have to repopulate /etc/resolv.conf with your DNS servers, since the 'network' service doesn't back up anything thin resolv.conf anywhere and thus tools like NM, vpnc, ppp, etc will overwrite resolv.conf when they have new DNS info.  Ideally all those would respect PEERDNS=no too.  But if you've turned off NM and refreshed your resolv.conf then NM wouldn't have anything to do with it.
Comment 6 Matt Castelein 2008-10-08 17:49:59 EDT
(In reply to comment #5)
> If you've 'chkconfig NetworkManager off' then NM won't have anything to do with
> writing out your resolv.conf.  After turning NM off, you'll have to repopulate
> /etc/resolv.conf with your DNS servers, since the 'network' service doesn't
> back up anything thin resolv.conf anywhere and thus tools like NM, vpnc, ppp,
> etc will overwrite resolv.conf when they have new DNS info.  Ideally all those
> would respect PEERDNS=no too.  But if you've turned off NM and refreshed your
> resolv.conf then NM wouldn't have anything to do with it.

Allright, I'll try it again..
Comment 7 Tom Tromey 2008-10-15 13:23:44 EDT
This got marked as needinfo from me ... but I answered the only
question I can see back in comment #2.
Is there something more I should provide?
Comment 8 Dan Williams 2008-10-16 11:17:47 EDT
Sorry, needinfo from Matt.
Comment 9 Matt Castelein 2008-10-16 11:23:27 EDT
This worked the next time around.  I'm all set.
Comment 10 Dan Williams 2008-10-19 22:42:45 EDT
Tom, do the DNS servers and search paths show up in the connection editor when you go back in and edit the connection again?  Lets try to narrow down where the issue could be.
Comment 11 malcolm 2008-11-05 15:48:08 EST
This seems to be similar to the problem I have

Install F10 with dhcp - everything OK

Then:- go to network and select manual
enter an IP address enter DNS servers etc
save then either restart network or restart PC

IP has been saved but DNS servers haven't

To get it to work: reselect dhcp so that the
set dns from dhcp check box is active - ( I think
thats what is is labled - I am not at work at the mo ) 
unselect it then re do manual set up and now 
it remembers DNS settings 

M
Comment 12 Bug Zapper 2008-11-26 06:13:28 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 13 Bug Zapper 2009-01-09 01:47:37 EST
Fedora 8 changed to end-of-life (EOL) status on 2009-01-07. Fedora 8 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 14 Tom Lane 2009-04-23 18:25:09 EDT
After being gone in F-10, this problem has come back in F-11: even though NetworkManager is allegedly disabled, it overwrites /etc/resolv.conf with incorrect information during system boot.

$ chkconfig --list NetworkManager
NetworkManager  0:off   1:off   2:off   3:off   4:off   5:off   6:off
$ cat /etc/resolv.conf
# Generated by NetworkManager


# No nameservers found; try putting DNS servers into your
# ifcfg files in /etc/sysconfig/network-scripts like so:
#
# DNS1=xxx.xxx.xxx.xxx
# DNS2=xxx.xxx.xxx.xxx
# DOMAIN=lab.foo.com bar.foo.com
nameserver 192.168.0.3
nameserver 192.168.0.14
$

Of course the above is not what was in /etc/resolv.conf immediately before rebooting.  I would not object so vehemently if the information were correct, but it's losing my "search" directive (which I carefully installed via system-config-network, not manually, in the hopes that that might know where it is that NetworkManager is looking for the information).

Back in F-9 I was using an /etc/rc.local script that overwrote /etc/resolv.conf with the information I need.  I guess I shall have to resort to that kluge again.

This is with a virgin install of  today's rawhide:
NetworkManager-glib-0.7.1-3.git20090414.fc11.i586
NetworkManager-0.7.1-3.git20090414.fc11.i586
NetworkManager-gnome-0.7.1-3.git20090414.fc11.i586
Comment 15 Dan Williams 2009-04-24 12:05:12 EDT
Oh come on.  Nothing runs NetworkManager if it's off in chkconfig.  NOTHING.  It does not get run.  Period.  Therefore, it cannot modify your resolv.conf.  AT ALL.

The only thing I can think of is that since system-config-network does some weird profile hardlinking, at some point when you were using system-config-network, it saved your resolv.conf to the other 2 locations that it puts stuff.

Check /etc/sysconfig/networking/profiles/* for a resolv.conf and see what's in that one.  If that one is incorrect as well, then my theory is correct.  Remove that file, re-run system-config-network, and set up your resolv.conf and it should stay that way.

Again, there's system-config-network interaction here that may well be the cause of the problem even if NM isn't involved.  Do you use the system-config-network "profiles" at all?
Comment 16 Tom Lane 2009-04-24 13:02:50 EDT
Hmm ... I did find an /etc/sysconfig/networking/profiles/default/resolv.conf that contained a copy of the bogus data, but fixing it did not immediately lead to a solution.  I found out that the network-scripts stuff will sometimes take it upon itself to modify /etc/resolv.conf, under conditions that aren't too clear to me (and heaven forbid there would be a comment anywhere...)  I now think that that code was somehow firing and regurgitating an old copy, but after several iterations of experimental poking it suddenly stopped happening.  Weird as can be.  Anyway, you're probably right that this is really network-scripts' fault and not NetworkManager's.

Note You need to log in before you can comment on or make changes to this bug.